import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.io.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

class clobtodom {
  static Document cars;
  static Element carsroot;

  public static void main(String argv[]) {
    try {
      String url = "jdbc:oracle:thin:@teak.csit.fsu.edu:1521:teak";
      String query, condition;
      int	i;
      //byte[] bytes;

      DocumentBuilderFactory carsdbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder carsdb = carsdbf.newDocumentBuilder();
      cars = carsdb.newDocument();
      carsroot = cars.createElement ("cars");
      cars.appendChild(carsroot);

      Class.forName( "oracle.jdbc.driver.OracleDriver" ); 

      System.out.println("Please enter information to connection to the database");
      String user;
      String password;

      user = readEntry ("user: ");
      password = readEntry ("password: ");

      Connection conn = 
        DriverManager.getConnection(url, user, password);

      Statement stat = conn.createStatement();

      Clob clob;
      
      query = "select * from xmltest";
      ResultSet rs = stat.executeQuery(query);

      while ( rs.next() ) {
        int index = ((OracleResultSet)rs).getInt(1);
        clob = ((OracleResultSet)rs).getClob(2);

        int length = (int)clob.length();

        System.out.println("Clob length " + length);

        InputStream clobis = clob.getAsciiStream();

        addXML( clobis );
      }

      System.out.println("\n---------------------------");
      printXMLDocument();
      System.out.println("\n---------------------------");
      conn.close();
      System.out.println("End of Clob access");
    } catch ( Exception e ) {
      System.err.println("Exception: "+e);
      e.printStackTrace();
    }
  }

  static String readEntry (String prompt) {
    try {
      StringBuffer buffer = new StringBuffer();
      System.out.print (prompt);
      System.out.flush();
      int c = System.in.read();
      while (c != '\n' && c !=-1) {
        buffer.append ((char)c);
        c = System.in.read();
      }
      return buffer.toString().trim();
    }
    catch (IOException e) {
      return "";
    }
  }

  static void addXML (InputStream xmlis) {

    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse( xmlis );

      Element xmlroot = doc.getDocumentElement();
      Node inode = cars.importNode( xmlroot, true );
      Element clone = (Element)inode.cloneNode (true);
      carsroot.appendChild( clone );
    }
    catch(Exception e) {
      System.out.println(e.getMessage());
    }
  }

  static void printXMLDocument () {

    try {
      TransformerFactory tFactory =
        TransformerFactory.newInstance();
      Transformer tf = tFactory.newTransformer();
      DOMSource source = new DOMSource(cars);
      StreamResult result = new StreamResult(System.out);
      tf.transform(source, result);
    }
    catch (Exception e) {
      System.out.println(e.getMessage());
    }
  }

  static void printXMLDocument (byte[] bytes, int length) {

    ByteArrayInputStream is = new ByteArrayInputStream(bytes, 0, length);

    try {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      DocumentBuilder db = dbf.newDocumentBuilder();
      Document doc = db.parse( is );

      TransformerFactory tFactory =
        TransformerFactory.newInstance();
      Transformer tf = tFactory.newTransformer();

      DOMSource source = new DOMSource(doc);
      StreamResult result = new StreamResult(System.out);
      tf.transform(source, result);
      is.close();
    }
    catch (Exception e) {
      System.out.println(e.getMessage());
    }
  }
}
